Global *ptEcran,lgEcran

Procedure.w compute_outcode(x.w, y.w, xmin.w, ymin.w, xmax.w, ymax.w)
    oc.w = 0
 
    If (y > ymax)
	    oc = oc | %0001
	  Else 
	    If (y < ymin)
        oc = oc |%0010
      EndIf
    EndIf
 
    If (x > xmax)
	    oc = oc | %0100
	  Else
	    If (x < xmin)
	      oc = oc | %1000
      EndIf
    EndIf
    
    ProcedureReturn oc;
 EndProcedure
 

Procedure LigneRetro(x1,y1,x2,y2,couleur)
  coul.q = couleur<<32 + couleur
  
  xmin = 0;deportx /2
  xmax = xres ;xmin + 320
  ymin = 0;deporty / 2
  ymax = yres;ymin + 200
  
  accept.w = 0
  done.w = 0
  outcode1.w = 0
  outcode2.w = 0
  
  
  outcode1 = compute_outcode (x1, y1, xmin, ymin, xmax, ymax);
  outcode2 = compute_outcode (x2, y2, xmin, ymin, xmax, ymax);
  While (done = 0); 
  	If (outcode1 = 0) And (outcode2 = 0)
  	
  	    accept = 1;
  	    done = 1;
  	
  	Else
  	  If (outcode1 & outcode2)  ; cas ou tout est dehors!
  	    done = 1;
  	  Else
  	    x.i
  	    y.i
  	    If outcode1<>0
  	      outcode_ex.w = outcode1
  	    Else
  	      outcode_ex.w = outcode2
  	    EndIf
  	    ;outcode_ex.w = outcode1 ? outcode1 : outcode2;
  	    
  	    If (outcode_ex & %0001)
      		x = x1 + (x2 - x1) * (ymax - y1) / (y2 - y1)
      		y = ymax
          
  	    Else
  	      If (outcode_ex & %0010)
        		x = x1 + (x2 - x1) * (ymin - y1) / (y2 - y1);
        		y = ymin;
  	      Else
  	        If (outcode_ex & %0100)
          		y = y1 + (y2 - y1) * (xmax - x1) / (x2 - x1);
          		x = xmax;
  	        Else
          		y = y1 + (y2 - y1) * (xmin - x1) / (x2 - x1);
          		x = xmin;
  		      EndIf
  	      EndIf
  	    EndIf
          If (outcode_ex = outcode1)
          		x1 = x;
          		y1 = y;
          		outcode1 = compute_outcode (x1, y1, xmin, ymin, xmax, ymax);
          Else
          		x2 = x;
          		y2 = y;
          		outcode2 = compute_outcode (x2, y2, xmin, ymin, xmax, ymax);
          EndIf
  	  EndIf
    EndIf
  Wend
  
  
  If (accept = 0)
    ProcedureReturn
  EndIf

  If Abs(x2-x1) > Abs(y2-y1)
    If x1>x2
      Swap x1,x2
      Swap y1,y2
    EndIf
    y = 0
    inc.i = Int(((y2-y1)/Abs(x2-x1))*65536)
    *ecran = *ptEcran + y1*lgEcran
    For j = x1 To x2 
      PokeQ(*ecran + (y>>16)*lgEcran + j*4 , coul) 
      y = y + inc
    Next      
  Else
    If Abs(x2-x1) = Abs(y2-y1)
      If x1>x2
        Swap x1,x2
        Swap y1,y2
      EndIf
      y.i = 0
      inc.i = Int(((y2-y1)/Abs(x2-x1))*65536)
      *ecran = *ptEcran + y1*lgEcran
      For j = x1 To x2 
        PokeQ(*ecran + (y>>16)*lgEcran + j*4 , coul) 
         y = y + inc
      Next      
    Else
       If y1>y2
        Swap x1,x2
        Swap y1,y2
       EndIf
       x.i = 0
       inc.i = Int(((x2-x1)/Abs(y2-y1))*65536)
       *ecran = *ptEcran + y1*lgEcran + x1*4
       For j = y1 To y2 
         PokeQ(*ecran + (x>>16)<<2 , coul) 
         *ecran = *ecran + lgEcran
         x = x + inc
       Next      
    EndIf
  EndIf
  
EndProcedure


Procedure cohen_sutherland(x1.w, y1.w, x2.w, y2.w, xmin.w, ymin.w, xmax.w, ymax.w,couleur)
    accept.w = 0
    done.w = 0
    outcode1.w = 0
    outcode2.w = 0
 
 
    outcode1 = compute_outcode (x1, y1, xmin, ymin, xmax, ymax);
    outcode2 = compute_outcode (x2, y2, xmin, ymin, xmax, ymax);
    While (done = 0); 
    	If (outcode1 = 0) And (outcode2 = 0)
    	
    	    accept = 1;
    	    done = 1;
    	
    	Else
    	  If (outcode1 & outcode2)  ; cas ou tout est dehors!
    	    done = 1;
    	  Else
    	    x.w
    	    y.w
    	    If outcode1<>0
    	      outcode_ex.w = outcode1
    	    Else
    	      outcode_ex.w = outcode2
    	    EndIf
    	    ;outcode_ex.w = outcode1 ? outcode1 : outcode2;
    	    
    	    If (outcode_ex & %0001)
        		x = x1 + (x2 - x1) * (ymax - y1) / (y2 - y1)
        		y = ymax
            
    	    Else
    	      If (outcode_ex & %0010)
          		x = x1 + (x2 - x1) * (ymin - y1) / (y2 - y1);
          		y = ymin;
    	      Else
    	        If (outcode_ex & %0100)
            		y = y1 + (y2 - y1) * (xmax - x1) / (x2 - x1);
            		x = xmax;
    	        Else
            		y = y1 + (y2 - y1) * (xmin - x1) / (x2 - x1);
            		x = xmin;
    		      EndIf
    	      EndIf
    	    EndIf
 	        If (outcode_ex = outcode1)
            		x1 = x;
            		y1 = y;
            		outcode1 = compute_outcode (x1, y1, xmin, ymin, xmax, ymax);
 	        Else
            		x2 = x;
            		y2 = y;
            		outcode2 = compute_outcode (x2, y2, xmin, ymin, xmax, ymax);
 	        EndIf
    	  EndIf
  	  EndIf
  	Wend
  	
 
  	If (accept = 1)
  	  ;Debug Str(x1)+" "+Str(y1)+" "+Str(x2)+" "+Str(y2)
      LigneRetro (x1, y1, x2, y2,couleur)
    EndIf
EndProcedure
 

  
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 73
; FirstLine = 38
; Folding = -
; EnableXP