Procedure calculSpin(scale.f=1.0)
  CalcMatrix(@matrice,angleX,angleY,angleZ,scale) ; scale = 1.0
  
  Tx=-50.0 + incPos
  Ty= 50.0 + incPos
  Tz= 50.0 + incPos

  RotateObject(@objects(0),@matrice,Tx,Ty,Tz) 
  translateObject(@objects(0),0,0,0) 
  Tx + (100.0 + incPos*2)
  RotateObject(@objects(1),@matrice,Tx,Ty,Tz) 
  translateObject(@objects(1),0,0,0) 
  Tz - (100.0 + incPos*2)
  RotateObject(@objects(2),@matrice,Tx,Ty,Tz)
  translateObject(@objects(2),0,0,0)
  Tx - (100.0 + incPos*2)
  RotateObject(@objects(3),@matrice,Tx,Ty,Tz)
  translateObject(@objects(3),0,0,0)
  Ty - (100.0 + incPos*2)
  Tz + (100.0 + incPos*2)
  RotateObject(@objects(4),@matrice,Tx,Ty,Tz)
  translateObject(@objects(4),0,0,0)
  Tx + (100.0 + incPos*2)
  RotateObject(@objects(5),@matrice,Tx,Ty,Tz)
  translateObject(@objects(5),0,0,0)
  Tz - (100.0 + incPos*2)
  RotateObject(@objects(6),@matrice,Tx,Ty,Tz)
  translateObject(@objects(6),0,0,0)  
  Tx - (100.0 + incPos*2)
  RotateObject(@objects(7),@matrice,Tx,Ty,Tz)
  translateObject(@objects(7),0,0,0) 
EndProcedure

Procedure effetOmbre1(sprite,efface=#False)
  
  ;Displaying shadow effect
  Sprite3DBlendingMode(5,13)
  Select sprite
    Case 1
      ZoomSprite3D(101,SpriteWidth(1)*2,SpriteHeight(1)*2)
      xsp = -220+(Int(50*Cos(angleX)*Cos(angleY)/20)*20)
      ysp = -220+(Int(50*Sin(angleX+angleY)/20)*20)
      DisplaySprite3D(101,xres/2+xsp,yres/2+ysp)
      If efface
        Sprite3DBlendingMode(5,6)
        ZoomSprite3D(111,SpriteWidth(11)*2,SpriteHeight(11)*2)
        DisplaySprite3D(111,xres/2-220,yres/2-220)
      EndIf  
    Case 2
      ZoomSprite3D(103,SpriteWidth(3)*2,SpriteHeight(3)*2)
      xsp = -240+(Int(50*Cos(angleX)*Cos(angleY)/40)*40)
      ysp = -240+(Int(50*Sin(angleX+angleY)/40)*40)
      DisplaySprite3D(103,xres/2+xsp,yres/2+ysp)  
      If efface
        Sprite3DBlendingMode(5,6)
        ZoomSprite3D(111,SpriteWidth(11)*2,SpriteHeight(11)*2)
        DisplaySprite3D(111,xres/2-240,yres/2-240)
      EndIf  
  EndSelect
 
EndProcedure

Procedure effetOmbre2(sprite)
  Select sprite
    Case 1
      ;affichage de l'ombre 
      Sprite3DBlendingMode(12,4)
      ZoomSprite3D(102,SpriteWidth(2)*2,SpriteHeight(2)*2)
      xsp = -220+(Int(50*Cos(angleX)*Cos(angleY)/20)*20)
      ysp = -220+(Int(50*Sin(angleX+angleY)/20)*20)
      DisplaySprite3D(102,xres/2+xsp,yres/2+ysp)
    Case 2
      ;affichage de l'ombre 
      Sprite3DBlendingMode(12,4)
      ZoomSprite3D(104,SpriteWidth(3)*2,SpriteHeight(3)*2)
      xsp = -240+(Int(50*Cos(angleX)*Cos(angleY)/40)*40)
      ysp = -240+(Int(50*Sin(angleX+angleY)/40)*40)
      DisplaySprite3D(104,xres/2+xsp,yres/2+ysp)
  EndSelect
  
EndProcedure

Structure D3DTLVERTEX
  x.f
  y.f
  z.f
  rhw.f
  Color.l
  tu.f
  tv.f
EndStructure

Structure PB_DX9Sprite3D
  TexRes.l ; TexRes
  Vertice.D3DTLVERTEX[4] ; The 4 vertices for the rectangle sprite
  TmpVertice.D3DTLVERTEX[4] ; The 4 vertices for the rectangle sprite
  Width.l ; width set with ZoomSprite3D()
  Height.l ; height set with ZoomSprite3D()
  RealWidth.l
  RealHeight.l
  Angle.f
  Transformed.l
EndStructure

CompilerIf Defined(PB_MirrorSprite3D_None, #PB_Constant)=0
   #MirrorSprite3D_None=0
   #MirrorSprite3D_Horizontal=1
   #MirrorSprite3D_Vertical=2
   #MirrorSprite3D_Both=#MirrorSprite3D_Horizontal | #MirrorSprite3D_Vertical
CompilerEndIf

Procedure MirrorSprite3D(Sprite3D, MirrorMode) ;Mirror 3D sprite image (returns TRUE if any changes)
   Protected *Sprite3D.PB_DX9Sprite3D=IsSprite3D(Sprite3D)
   Protected MirroringChanges.b=0
   Protected IsMirrored.b
   Protected DoMirroring.b
   
   IsMirrored=*Sprite3D\Vertice[0]\tu>*Sprite3D\Vertice[1]\tu
   DoMirroring=1 And MirrorMode & #MirrorSprite3D_Horizontal
   If (DoMirroring And IsMirrored=0) Or (DoMirroring=0 And IsMirrored)
      MirroringChanges=1
      Swap *Sprite3D\Vertice[0]\tu, *Sprite3D\Vertice[1]\tu
      Swap *Sprite3D\Vertice[2]\tu, *Sprite3D\Vertice[3]\tu
   EndIf
   
   IsMirrored=*Sprite3D\Vertice[0]\tv>*Sprite3D\Vertice[3]\tv
   DoMirroring=1 And MirrorMode & #MirrorSprite3D_Vertical
   If (DoMirroring And IsMirrored=0) Or (DoMirroring=0 And IsMirrored)
      MirroringChanges=1
      Swap *Sprite3D\Vertice[0]\tv, *Sprite3D\Vertice[3]\tv
      Swap *Sprite3D\Vertice[1]\tv, *Sprite3D\Vertice[2]\tv
   EndIf
   
   ProcedureReturn MirroringChanges
 EndProcedure
 
Procedure SetColorSprite3D(sprite3d, Color.l)
  Protected *Sprite3D.PB_DX9Sprite3D = IsSprite3D(sprite3d)
  With *Sprite3D
    \Vertice[0]\Color = Color.l
    \Vertice[1]\Color = Color.l
    \Vertice[2]\Color = Color.l
    \Vertice[3]\Color = Color.l
  EndWith
EndProcedure 

Procedure ClipSprite3D(Sprite3D,ClipX,ClipY,ClipWidth,ClipHeight)
  Protected *ptr.PB_DX9Sprite3D = IsSprite3D(Sprite3D)
  
  If *ptr = 0 : ProcedureReturn #False : EndIf
  
  If ClipX < 0 : ClipX = 0 : EndIf
  If ClipY < 0 : ClipY = 0 : EndIf
  
  If ClipWidth < 0 : ClipWidth = 0 : EndIf
  If ClipHeight < 0 : ClipHeight = 0 : EndIf
  
  If ClipX > *ptr\RealWidth : ClipX = *ptr\RealWidth : EndIf
  If ClipY > *ptr\RealHeight : ClipY = *ptr\RealHeight : EndIf
  
  If ClipX + ClipWidth > *ptr\RealWidth : ClipWidth = *ptr\RealWidth - ClipX : EndIf
  If ClipY + ClipHeight > *ptr\RealHeight : ClipHeight = *ptr\RealHeight - ClipY : EndIf
  
  *ptr\Vertice[0]\tu = ClipX / *ptr\RealWidth
  *ptr\Vertice[0]\tv = ClipY / *ptr\RealHeight
  
  *ptr\Vertice[1]\tu = (ClipX + ClipWidth) / *ptr\RealWidth
  *ptr\Vertice[1]\tv = ClipY / *ptr\RealHeight
  
  *ptr\Vertice[2]\tu = ClipX / *ptr\RealWidth
  *ptr\Vertice[2]\tv = (ClipY + ClipHeight) / *ptr\RealHeight
  
  *ptr\Vertice[3]\tu = (ClipX + ClipWidth) / *ptr\RealWidth
  *ptr\Vertice[3]\tv = (ClipY + ClipHeight) / *ptr\RealHeight
  
  ProcedureReturn #True
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 105
; FirstLine = 8
; Folding = 4-
; EnableXP